## postgresql-16 16.10

=== meson_options.txt ===
# Copyright (c) 2022-2023, PostgreSQL Global Development Group

# Data layout influencing options

option('blocksize', type: 'combo',
  choices: ['1', '2', '4', '8', '16', '32'],
  value: '8',
  description: 'Relation block size, in kilobytes')

option('wal_blocksize', type: 'combo',
  choices: ['1', '2', '4', '8', '16', '32', '64'],
  value: '8',
  description: 'WAL block size, in kilobytes')

option('segsize', type: 'integer', value: 1,
  description: 'Segment size, in gigabytes')

option('segsize_blocks', type: 'integer', value: 0,
  description: 'Segment size, in blocks')


# Miscellaneous options

option('krb_srvnam', type: 'string', value: 'postgres',
  description: 'Default Kerberos service principal for GSSAPI')

option('system_tzdata', type: 'string', value: '',
  description: 'Use system time zone data in specified directory')


# Defaults

option('pgport', type: 'integer', value: 5432,
  min: 1, max: 65535,
  description: 'Default port number for server and clients')


# Developer options

option('cassert', type: 'boolean', value: false,
  description: 'Enable assertion checks (for debugging)')

option('tap_tests', type: 'feature', value: 'auto',
  description: 'Enable TAP tests')

option('PG_TEST_EXTRA', type: 'string', value: '',
  description: 'Enable selected extra tests')

option('atomics', type: 'boolean', value: true,
  description: 'Use atomic operations')

option('spinlocks', type: 'boolean', value: true,
  description: 'Use spinlocks')


# Compilation options

option('extra_include_dirs', type: 'array', value: [],
  description: 'Non-default directories to be searched for headers')

option('extra_lib_dirs', type: 'array', value: [],
  description: 'Non-default directories to be searched for libs')

option('extra_version', type: 'string', value: '',
  description: 'Append STRING to the PostgreSQL version number')

option('darwin_sysroot', type: 'string', value: '',
  description: 'Select a non-default sysroot path')

option('rpath', type: 'boolean', value: true,
  description: 'Embed shared library search path in executables')


# External dependencies

option('bonjour', type: 'feature', value: 'auto',
  description: 'Bonjour support')

option('bsd_auth', type: 'feature', value: 'auto',
  description: 'BSD Authentication support')

option('docs', type: 'feature', value: 'auto',
  description: 'Documentation in HTML and man page format')

option('docs_pdf', type: 'feature', value: 'auto',
  description: 'Documentation in PDF format')

option('docs_html_style', type: 'combo', choices: ['simple', 'website'],
  description: 'CSS stylesheet for HTML documentation')

option('dtrace', type: 'feature', value: 'disabled',
  description: 'DTrace support')

option('gssapi', type: 'feature', value: 'auto',
  description: 'GSSAPI support')

option('icu', type: 'feature', value: 'auto',
  description: 'ICU support')

option('ldap', type: 'feature', value: 'auto',
  description: 'LDAP support')

option('libedit_preferred', type: 'boolean', value: false,
  description: 'Prefer BSD Libedit over GNU Readline')

option('libxml', type: 'feature', value: 'auto',
  description: 'XML support')

option('libxslt', type: 'feature', value: 'auto',
  description: 'XSLT support in contrib/xml2')

option('llvm', type: 'feature', value: 'disabled',
  description: 'LLVM support')

option('lz4', type: 'feature', value: 'auto',
  description: 'LZ4 support')

option('nls', type: 'feature', value: 'auto',
  description: 'Native language support')

option('pam', type: 'feature', value: 'auto',
  description: 'PAM support')

option('plperl', type: 'feature', value: 'auto',
  description: 'Build Perl modules (PL/Perl)')

option('plpython', type: 'feature', value: 'auto',
  description: 'Build Python modules (PL/Python)')

option('pltcl', type: 'feature', value: 'auto',
  description: 'Build with Tcl support (PL/Tcl)')

option('tcl_version', type: 'string', value: 'tcl',
  description: 'Tcl version')

option('readline', type: 'feature', value: 'auto',
  description: 'Use GNU Readline or BSD Libedit for editing')

option('selinux', type: 'feature', value: 'disabled',
  description: 'SELinux support')

option('ssl', type: 'combo', choices: ['auto', 'none', 'openssl'],
  value: 'auto',
  description: 'Use LIB for SSL/TLS support (openssl)')

option('systemd', type: 'feature', value: 'auto',
  description: 'systemd support')

option('uuid', type: 'combo', choices: ['none', 'bsd', 'e2fs', 'ossp'],
  value: 'none',
  description: 'Use LIB for contrib/uuid-ossp support')

option('zlib', type: 'feature', value: 'auto',
  description: 'Enable zlib')

option('zstd', type: 'feature', value: 'auto',
  description: 'Enable zstd')


# Programs

option('BISON', type: 'array', value: ['bison', 'win_bison'],
  description: 'Path to bison binary')

option('DTRACE', type: 'string', value: 'dtrace',
  description: 'Path to dtrace binary')

option('FLEX', type: 'array', value: ['flex', 'win_flex'],
  description: 'Path to flex binary')

option('FOP', type: 'string', value: 'fop',
  description: 'Path to fop binary')

option('GZIP', type: 'string', value: 'gzip',
  description: 'Path to gzip binary')

option('LZ4', type: 'string', value: 'lz4',
  description: 'Path to lz4 binary')

option('OPENSSL', type: 'string', value: 'openssl',
  description: 'Path to openssl binary')

option('PERL', type: 'string', value: 'perl',
  description: 'Path to perl binary')

option('PROVE', type: 'string', value: 'prove',
  description: 'Path to prove binary')

option('PYTHON', type: 'array', value: ['python3', 'python'],
  description: 'Path to python binary')

option('SED', type: 'string', value: 'gsed',
  description: 'Path to sed binary')

option('STRIP', type: 'string', value: 'strip',
  description: 'Path to strip binary, used for PGXS emulation')

option('TAR', type: 'string', value: 'tar',
  description: 'Path to tar binary')

option('XMLLINT', type: 'string', value: 'xmllint',
  description: 'Path to xmllint binary')

option('XSLTPROC', type: 'string', value: 'xsltproc',
  description: 'Path to xsltproc binary')

option('ZSTD', type: 'string', value: 'zstd',
  description: 'Path to zstd binary')

option('ZIC', type: 'string', value: 'zic',
  description: 'Path to zic binary, when cross-compiling')

=== contrib/Makefile ===
# contrib/Makefile

subdir = contrib
top_builddir = ..
include $(top_builddir)/src/Makefile.global

SUBDIRS = \
		adminpack	\
		amcheck		\
		auth_delay	\
		auto_explain	\
		basic_archive	\
		basebackup_to_shell	\
		bloom		\
		btree_gin	\
		btree_gist	\
		citext		\
		cube		\
		dblink		\
		dict_int	\
		dict_xsyn	\
		earthdistance	\
		file_fdw	\
		fuzzystrmatch	\
		hstore		\
		intagg		\
		intarray	\
		isn		\
		lo		\
		ltree		\
		oid2name	\
		old_snapshot	\
		pageinspect	\
		passwordcheck	\
		pg_buffercache	\
		pg_freespacemap \
		pg_prewarm	\
		pg_stat_statements \
		pg_surgery	\
		pg_trgm		\
		pgrowlocks	\
		pgstattuple	\
		pg_visibility	\
		pg_walinspect	\
		postgres_fdw	\
		seg		\
		spi		\
		tablefunc	\
		tcn		\
		test_decoding	\
		tsm_system_rows \
		tsm_system_time \
		unaccent	\
		vacuumlo

ifeq ($(with_ssl),openssl)
SUBDIRS += pgcrypto sslinfo
else
ALWAYS_SUBDIRS += pgcrypto sslinfo
endif

ifneq ($(with_uuid),no)
SUBDIRS += uuid-ossp
else
ALWAYS_SUBDIRS += uuid-ossp
endif

ifeq ($(with_libxml),yes)
SUBDIRS += xml2
else
ALWAYS_SUBDIRS += xml2
endif

ifeq ($(with_selinux),yes)
SUBDIRS += sepgsql
else
ALWAYS_SUBDIRS += sepgsql
endif

ifeq ($(with_perl),yes)
SUBDIRS += bool_plperl hstore_plperl jsonb_plperl
else
ALWAYS_SUBDIRS += bool_plperl hstore_plperl jsonb_plperl
endif

ifeq ($(with_python),yes)
SUBDIRS += hstore_plpython jsonb_plpython ltree_plpython
else
ALWAYS_SUBDIRS += hstore_plpython jsonb_plpython ltree_plpython
endif

# Missing:
#		start-scripts	\ (does not have a makefile)


$(recurse)
$(recurse_always)

=== src/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src
#
# Copyright (c) 1994, Regents of the University of California
#
# src/Makefile
#
#-------------------------------------------------------------------------

subdir = src
top_builddir = ..
include Makefile.global

SUBDIRS = \
	common \
	port \
	timezone \
	backend \
	backend/utils/mb/conversion_procs \
	backend/snowball \
	include \
	interfaces \
	backend/replication/libpqwalreceiver \
	backend/replication/pgoutput \
	fe_utils \
	bin \
	pl \
	makefiles \
	test/regress \
	test/isolation \
	test/perl

ifeq ($(with_llvm), yes)
SUBDIRS += backend/jit/llvm
endif

# There are too many interdependencies between the subdirectories, so
# don't attempt parallel make here.
.NOTPARALLEL:

$(recurse)

install: install-local

install-local: installdirs-local
	$(INSTALL_DATA) Makefile.global '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.global'
	$(INSTALL_DATA) Makefile.port '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.port'
	$(INSTALL_DATA) $(srcdir)/Makefile.shlib '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.shlib'
	$(INSTALL_DATA) $(srcdir)/nls-global.mk '$(DESTDIR)$(pgxsdir)/$(subdir)/nls-global.mk'

installdirs: installdirs-local

installdirs-local:
	$(MKDIR_P) '$(DESTDIR)$(pgxsdir)/$(subdir)'

uninstall: uninstall-local

uninstall-local:
	rm -f $(addprefix '$(DESTDIR)$(pgxsdir)/$(subdir)'/, Makefile.global Makefile.port Makefile.shlib nls-global.mk)

distprep:
	$(MAKE) -C test/isolation $@

clean:
	$(MAKE) -C test $@
	$(MAKE) -C tutorial NO_PGXS=1 $@
	$(MAKE) -C test/isolation $@
	$(MAKE) -C tools/pg_bsd_indent $@

distclean maintainer-clean:
	$(MAKE) -C test $@
	$(MAKE) -C tutorial NO_PGXS=1 $@
	$(MAKE) -C test/isolation $@
	$(MAKE) -C tools/pg_bsd_indent $@
	rm -f Makefile.port Makefile.global


.PHONY: install-local installdirs-local uninstall-local

=== contrib/adminpack/Makefile ===
# contrib/adminpack/Makefile

MODULE_big = adminpack
OBJS = \
	$(WIN32RES) \
	adminpack.o

EXTENSION = adminpack
DATA = adminpack--1.0.sql adminpack--1.0--1.1.sql adminpack--1.1--2.0.sql\
	adminpack--2.0--2.1.sql
PGFILEDESC = "adminpack - support functions for pgAdmin"

REGRESS = adminpack

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/adminpack
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== contrib/cube/Makefile ===
# contrib/cube/Makefile

MODULE_big = cube
OBJS = \
	$(WIN32RES) \
	cube.o \
	cubeparse.o \
	cubescan.o

EXTENSION = cube
DATA = cube--1.2.sql cube--1.2--1.3.sql cube--1.3--1.4.sql cube--1.4--1.5.sql \
	cube--1.1--1.2.sql cube--1.0--1.1.sql
PGFILEDESC = "cube - multidimensional cube data type"

HEADERS = cubedata.h

REGRESS = cube cube_sci

SHLIB_LINK += $(filter -lm, $(LIBS))

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/cube
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

# See notes in src/backend/parser/Makefile about the following two rules
cubeparse.h: cubeparse.c
	touch $@

cubeparse.c: BISONFLAGS += -d

# Force these dependencies to be known even without dependency info built:
cubeparse.o cubescan.o: cubeparse.h

distprep: cubeparse.c cubescan.c

maintainer-clean:
	rm -f cubeparse.h cubeparse.c cubescan.c

=== contrib/fuzzystrmatch/Makefile ===
# contrib/fuzzystrmatch/Makefile

MODULE_big = fuzzystrmatch
OBJS = \
	$(WIN32RES) \
	daitch_mokotoff.o \
	dmetaphone.o \
	fuzzystrmatch.o

EXTENSION = fuzzystrmatch
DATA = fuzzystrmatch--1.1.sql fuzzystrmatch--1.1--1.2.sql \
	fuzzystrmatch--1.0--1.1.sql

PGFILEDESC = "fuzzystrmatch - similarities and distance between strings"

REGRESS = fuzzystrmatch fuzzystrmatch_utf8

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/fuzzystrmatch
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

# Force this dependency to be known even without dependency info built:
daitch_mokotoff.o: daitch_mokotoff.h

daitch_mokotoff.h: daitch_mokotoff_header.pl
	$(PERL) $< $@

# daitch_mokotoff.h is included in tarballs, so it has to be made by
# "distprep" and not cleaned except by "maintainer-clean".
distprep: daitch_mokotoff.h

maintainer-clean:
	rm -f daitch_mokotoff.h

=== contrib/intagg/Makefile ===
# contrib/intagg/Makefile

EXTENSION = intagg
DATA = intagg--1.1.sql intagg--1.0--1.1.sql

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/intagg
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== contrib/intarray/Makefile ===
# contrib/intarray/Makefile

MODULE_big = _int
OBJS = \
	$(WIN32RES) \
	_int_bool.o \
	_int_gin.o \
	_int_gist.o \
	_int_op.o \
	_int_selfuncs.o \
	_int_tool.o \
	_intbig_gist.o

EXTENSION = intarray
DATA = intarray--1.4--1.5.sql intarray--1.3--1.4.sql intarray--1.2--1.3.sql \
	intarray--1.2.sql intarray--1.1--1.2.sql \
	intarray--1.0--1.1.sql
PGFILEDESC = "intarray - functions and operators for arrays of integers"

REGRESS = _int

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/intarray
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== contrib/pg_prewarm/Makefile ===
# contrib/pg_prewarm/Makefile

MODULE_big = pg_prewarm
OBJS = \
	$(WIN32RES) \
	autoprewarm.o \
	pg_prewarm.o

EXTENSION = pg_prewarm
DATA = pg_prewarm--1.1--1.2.sql pg_prewarm--1.1.sql pg_prewarm--1.0--1.1.sql
PGFILEDESC = "pg_prewarm - preload relation data into system buffer cache"

TAP_TESTS = 1

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/pg_prewarm
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== src/bin/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin (client programs)
#
# Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/bin/Makefile
#
#-------------------------------------------------------------------------

subdir = src/bin
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

SUBDIRS = \
	initdb \
	pg_amcheck \
	pg_archivecleanup \
	pg_basebackup \
	pg_checksums \
	pg_config \
	pg_controldata \
	pg_ctl \
	pg_dump \
	pg_resetwal \
	pg_rewind \
	pg_test_fsync \
	pg_test_timing \
	pg_upgrade \
	pg_verifybackup \
	pg_waldump \
	pgbench \
	psql \
	scripts

ifeq ($(PORTNAME), win32)
SUBDIRS += pgevent
else
ALWAYS_SUBDIRS += pgevent
endif

$(recurse)
$(recurse_always)

=== src/test/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/test
#
# Copyright (c) 1994, Regents of the University of California
#
# src/test/Makefile
#
#-------------------------------------------------------------------------

subdir = src/test
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

SUBDIRS = perl regress isolation modules authentication recovery subscription

ifeq ($(with_icu),yes)
SUBDIRS += icu
endif
ifeq ($(with_gssapi),yes)
SUBDIRS += kerberos
endif
ifeq ($(with_ldap),yes)
SUBDIRS += ldap
endif
ifeq ($(with_ssl),openssl)
SUBDIRS += ssl
endif

# Test suites that are not safe by default but can be run if selected
# by the user via the whitespace-separated list in variable PG_TEST_EXTRA.
# Export PG_TEST_EXTRA to check it in individual tap tests.
export PG_TEST_EXTRA

# We don't build or execute these by default, but we do want "make
# clean" etc to recurse into them.  (We must filter out those that we
# have conditionally included into SUBDIRS above, else there will be
# make confusion.)
ALWAYS_SUBDIRS = $(filter-out $(SUBDIRS),examples kerberos icu ldap ssl)

# We want to recurse to all subdirs for all standard targets, except that
# installcheck and install should not recurse into the subdirectory "modules".

recurse_alldirs_targets := $(filter-out installcheck install, $(standard_targets))
installable_dirs := $(filter-out modules, $(SUBDIRS))

$(call recurse,$(recurse_alldirs_targets))
$(call recurse,installcheck, $(installable_dirs))
$(call recurse,install, $(installable_dirs))

$(recurse_always)

=== src/backend/archive/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile--
#    Makefile for src/backend/archive
#
# IDENTIFICATION
#    src/backend/archive/Makefile
#
#-------------------------------------------------------------------------

subdir = src/backend/archive
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

OBJS = \
	shell_archive.o

include $(top_srcdir)/src/backend/common.mk

=== debian/changelog ===
postgresql-16 (16.10-0ubuntu0.24.04.1) noble-security; urgency=medium

  * New upstream version (LP: #2112531).

    + A dump/restore is not required for those running 16.X.

    + However, if you have any BRIN numeric_minmax_multi_ops indexes, it is
      advisable to reindex them after updating. Keep reading for further
      information.

    + Also, if you are upgrading from a version earlier than 16.9, see those
      release notes as well please.

    + Tighten security checks in planner estimation functions (Dean Rasheed)

      The fix for CVE-2017-7484, plus followup fixes, intended to prevent
      leaky functions from being applied to statistics data for columns that
      the calling user does not have permission to read. Two gaps in that
      protection have been found. One gap applies to partitioning and
      inheritance hierarchies where RLS policies on the tables should restrict
      access to statistics data, but did not.

      The other gap applies to cases where the query accesses a table via a
      view, and the view owner has permissions to read the underlying table
      but the calling user does not have permissions on the view. The view
      owner's permissions satisfied the security checks, and the leaky
      function would get applied to the underlying table's statistics before
      we check the calling user's permissions on the view. This has been fixed
      by making security checks on views occur at the start of planning. That
      might cause permissions failures to occur earlier than before.
      (CVE-2025-8713)

    + Prevent pg_dump scripts from being used to attack the user running the
      restore (Nathan Bossart)

      Since dump/restore operations typically involve running SQL commands as
      superuser, the target database installation must trust the source
      server. However, it does not follow that the operating system user who
      executes psql to perform the restore should have to trust the source
      server. The risk here is that an attacker who has gained superuser-level
      control over the source server might be able to cause it to emit text
      that would be interpreted as psql meta-commands. That would provide
      shell-level access to the restoring user's own account, independently of
      access to the target database.

      To provide a positive guarantee that this can't happen, extend psql with
      a \restrict command that prevents execution of further meta-commands,
      and teach pg_dump to issue that before any data coming from the source
      server. (CVE-2025-8714)

    + Convert newlines to spaces in names included in comments in pg_dump
      output (Noah Misch)

      Object names containing newlines offered the ability to inject arbitrary
      SQL commands into the output script. (Without the preceding fix,
      injection of psql meta-commands would also be possible this way.)
      CVE-2012-0868 fixed this class of problem at the time, but later work
      reintroduced several cases. (CVE-2025-8715)

    + Fix incorrect distance calculation in BRIN numeric_minmax_multi_ops
      support function (Peter Eisentraut, Tom Lane)

      The results were sometimes wrong on 64-bit platforms, and wildly wrong
      on 32-bit platforms. This did not produce obvious failures because the
      logic is only used to choose how to merge values into ranges; at worst
      the index would become inefficient and bloated. Nonetheless it's
      recommended to reindex any BRIN indexes that use the
      numeric_minmax_multi_ops operator class.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/16/release-16-10.html.

  * d/postgresql-16.NEWS: Update.

  * d/p/hurd-iovec: drop patch applied upstream.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 25 Aug 2025 17:36:09 -0300

postgresql-16 (16.9-0ubuntu0.24.04.1) noble-security; urgency=medium

  * New upstream version (LP: #2110377).

    + A dump/restore is not required for those running 16.X.

    + However, if you have any self-referential foreign key constraints on
      partitioned tables, it may be necessary to recreate those constraints to
      ensure that they are being enforced correctly. Follow the steps below to
      do so.

    + Also, if you have any BRIN bloom indexes, it may be advisable to reindex
      them after updating. Follow the steps below to do so.

    + Also, if you are upgrading from a version earlier than 16.5, see those
      release notes as well please.

    + Avoid one-byte buffer overread when examining invalidly-encoded strings
      that are claimed to be in GB18030 encoding (Noah Misch, Andres Freund)

      While unlikely, a SIGSEGV crash could occur if an incomplete multibyte
      character appeared at the end of memory. This was possible both in the
      server and in libpq-using applications. (CVE-2025-4207)

    + Handle self-referential foreign keys on partitioned tables correctly
      (Álvaro Herrera)

      Creating or attaching partitions failed to make the required catalog
      entries for a foreign-key constraint, if the table referenced by the
      constraint was the same partitioned table. This resulted in failure to
      enforce the constraint fully.

      To fix this, you should drop and recreate any self-referential foreign
      keys on partitioned tables, if partitions have been created or attached
      since the constraint was created. Bear in mind that violating rows might
      already be present, in which case recreating the constraint will fail,
      and you'll need to fix up those rows before trying again.

    + Avoid data loss when merging compressed BRIN summaries in
      brin_bloom_union() (Tomas Vondra)

      The code failed to account for decompression results not being identical
      to the input objects, which would result in failure to add some of the


=== debian/control ===
Source: postgresql-16
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Martin Pitt <mpitt@debian.org>,
 Peter Eisentraut <petere@debian.org>,
 Christoph Berg <myon@debian.org>,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends:
 autoconf,
 bison,
 clang-17 [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !loong64 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 debhelper-compat (= 13),
 dh-exec (>= 0.13~),
 docbook-xml,
 docbook-xsl (>= 1.77),
 dpkg-dev (>= 1.16.1~),
 flex,
 gdb <!nocheck>,
 gettext,
 libicu-dev,
 libio-pty-perl <!nocheck>,
 libipc-run-perl <!nocheck>,
 libkrb5-dev,
 libldap2-dev,
 liblz4-dev,
 libpam0g-dev | libpam-dev,
 libperl-dev,
 libreadline-dev,
 libselinux1-dev [linux-any],
 libssl-dev,
 libsystemd-dev [linux-any],
 libxml2-dev,
 libxml2-utils,
 libxslt1-dev,
 libzstd-dev (>= 1.4.0) <!pkg.postgresql.nozstd>,
 llvm-17-dev [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !loong64 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 lz4 | liblz4-tool,
 mawk,
 perl (>= 5.8),
 pkg-config,
 postgresql-common (>= 252~),
 python3-dev,
 systemtap-sdt-dev,
 tcl-dev,
 tzdata <!nocheck>,
 tzdata-legacy <!nocheck> | tzdata (<< 2023c-8) <!nocheck>,
 uuid-dev,
 xsltproc,
 zlib1g-dev | libz-dev,
 zstd (>= 1.4.0) <!pkg.postgresql.nozstd>,
Homepage: http://www.postgresql.org/
Vcs-Browser: https://salsa.debian.org/postgresql/postgresql
Vcs-Git: https://salsa.debian.org/postgresql/postgresql.git -b 16

Package: libpq-dev
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: libdevel
Depends:
 libpq5 (= ${binary:Version}),
 libssl-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 postgresql-doc-16,
Description: header files for libpq5 (PostgreSQL library)
 Header files and static library for compiling C programs to link
 with the libpq library in order to communicate with a PostgreSQL
 database backend.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpq5
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: PostgreSQL C client library
 libpq is a C library that enables user programs to communicate with
 the PostgreSQL database server.  The server can be on another machine
 and accessed through TCP/IP.  This version of libpq is compatible
 with servers from PostgreSQL 8.2 or later.
 .
 This package contains the run-time library, needed by packages using
 libpq.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg6
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: run-time library for ECPG programs
 The libecpg shared library is used by programs built with ECPG
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg-dev
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: libdevel
Depends:
 libecpg-compat3 (= ${binary:Version}),
 libecpg6 (= ${binary:Version}),
 libpgtypes3 (= ${binary:Version}),
 libpq-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: development files for ECPG (Embedded PostgreSQL for C)
 This package contains the necessary files to build ECPG (Embedded
 PostgreSQL for C) programs.  It includes the development libraries
 and the preprocessor program ecpg.
 .
 PostgreSQL is an object-relational SQL database management system.
 .
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

Package: libecpg-compat3
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: older version of run-time library for ECPG programs
 The libecpg_compat shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpgtypes3
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: shared library libpgtypes for PostgreSQL 16
 The libpgtypes shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-16
Architecture: any
Depends:
 locales | locales-all,
 postgresql-client-16,
 postgresql-common (>= 252~),
 ssl-cert,
 tzdata,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-contrib-16,
 postgresql-16-jit-llvm (= ${llvm:Version}) [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !loong64 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
Recommends:
 sysstat,
Breaks:
 dbconfig-common (<< 2.0.22~),
Description: The World's Most Advanced Open Source Relational Database
 PostgreSQL, also known as Postgres, is a free and open-source relational
 database management system (RDBMS) emphasizing extensibility and SQL
 compliance. It features transactions with Atomicity, Consistency, Isolation,
 Durability (ACID) properties, automatically updatable views, materialized
 views, triggers, foreign keys, and stored procedures. It is designed to handle
 a range of workloads, from single machines to data warehouses or Web services
 with many concurrent users.
 .
 This package provides the database server for PostgreSQL 16.${cassert}
XB-Postgresql-Catversion: ${postgresql:Catversion}

Package: postgresql-client-16
Architecture: any
Multi-Arch: foreign
Depends:
 libpq5 (>= ${source:Upstream-Version}),
 postgresql-client-common (>= 182~),
 sensible-utils,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 postgresql-16,
 postgresql-doc-16,
Provides:
 postgresql-client,
Description: front-end programs for PostgreSQL 16
 This package contains client and administrative programs for
 PostgreSQL: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for PostgreSQL 16. If you install
 PostgreSQL 16 on a standalone machine, you need the server package
 postgresql-16, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-server-dev-16
Architecture: any
Section: libdevel
Depends:
 clang-${llvm:Version} [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !loong64 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 libpq-dev (>= 16~~),
 llvm-${llvm:Version}-dev [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !loong64 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 postgresql-client-16,
 postgresql-common (>= 142~),
 ${misc:Depends},
 ${shlibs:Depends},
Description: development files for PostgreSQL 16 server-side programming
 Header files for compiling SSI code to link into PostgreSQL's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on
 modules of PostgreSQL, which would otherwise have to be built in the
 PostgreSQL source-code tree.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-doc-16
Architecture: all
Build-Profiles: <!nodoc>
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: documentation for the PostgreSQL database management system
 This package contains all README files, user manual, and examples for
 PostgreSQL 16. The manual is in HTML format.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plperl-16
Architecture: any
Depends:
 perl,
 postgresql-16 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-plperl,
Description: PL/Perl procedural language for PostgreSQL 16
 PL/Perl enables an SQL developer to write procedural language functions
 for PostgreSQL 16 in Perl.  You need this package if you have any
 PostgreSQL 16 functions that use the languages plperl or plperlu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plpython3-16
Architecture: any
Depends:
 postgresql-16 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-plpython3,
Description: PL/Python 3 procedural language for PostgreSQL 16
 PL/Python 3 enables an SQL developer to write procedural language functions
 for PostgreSQL 16 in Python 3.  You need this package if you have any
 PostgreSQL 16 functions that use the languages plpython3 or plpython3u.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-pltcl-16
Architecture: any
Depends:
 postgresql-16 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-pltcl,
Description: PL/Tcl procedural language for PostgreSQL 16
 PL/Tcl enables an SQL developer to write procedural language functions
 for PostgreSQL 16 in Tcl.  You need this package if you have any
 PostgreSQL 16 functions that use the languages pltcl or pltclu.
 .
 PostgreSQL is an object-relational SQL database management system.

=== debian/rules ===
#!/usr/bin/make -f

MAJOR_VER := 16

include /usr/share/postgresql-common/server/postgresql.mk

## postgresql-16 16.11

=== debian/changelog ===
postgresql-16 (16.11-1.pgdg25.10+1) questing-pgdg; urgency=medium

  * Rebuild for questing-pgdg.
  * Changes applied by generate-pgdg-source:
    + Moving lib packages to component 16.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 13 Aug 2025 23:39:33 +0200

postgresql-16 (16.11-1) unstable; urgency=medium

  * New upstream version 16.11.

    + Check for CREATE privileges on the schema in CREATE STATISTICS
      (Jelte Fennema-Nio)

      This omission allowed table owners to create statistics in any schema,
      potentially leading to unexpected naming conflicts.

      The PostgreSQL Project thanks Jelte Fennema-Nio for reporting this
      problem. (CVE-2025-12817)

    + Avoid integer overflow in allocation-size calculations within libpq
      (Jacob Champion)

      Several places in libpq were not sufficiently careful about computing
      the required size of a memory allocation.  Sufficiently large inputs
      could cause integer overflow, resulting in an undersized buffer, which
      would then lead to writing past the end of the buffer.

      The PostgreSQL Project thanks Aleksey Solovev of Positive Technologies
      for reporting this problem. (CVE-2025-12818)

 -- Christoph Berg <myon@debian.org>  Wed, 13 Aug 2025 23:39:33 +0200

postgresql-16 (16.10-1) unstable; urgency=medium

  * New upstream version 16.10.

    + Tighten security checks in planner estimation functions (Dean Rasheed)

      The fix for CVE-2017-7484, plus followup fixes, intended to prevent
      leaky functions from being applied to statistics data for columns that
      the calling user does not have permission to read.  Two gaps in that
      protection have been found.  One gap applies to partitioning and
      inheritance hierarchies where RLS policies on the tables should restrict
      access to statistics data, but did not.

      The other gap applies to cases where the query accesses a table via a
      view, and the view owner has permissions to read the underlying table
      but the calling user does not have permissions on the view. The view
      owner's permissions satisfied the security checks, and the leaky
      function would get applied to the underlying table's statistics before
      we check the calling user's permissions on the view.  This has been
      fixed by making security checks on views occur at the start of planning.
      That might cause permissions failures to occur earlier than before.

      The PostgreSQL Project thanks Dean Rasheed for reporting this problem.
      (CVE-2025-8713)

    + Prevent pg_dump scripts from being used to attack the user running the
      restore (Nathan Bossart)

      Since dump/restore operations typically involve running SQL commands as
      superuser, the target database installation must trust the source
      server.  However, it does not follow that the operating system user who
      executes psql to perform the restore should have to trust the source
      server.  The risk here is that an attacker who has gained
      superuser-level control over the source server might be able to cause it
      to emit text that would be interpreted as psql meta-commands. That would
      provide shell-level access to the restoring user's own account,
      independently of access to the target database.

      To provide a positive guarantee that this can't happen, extend psql with
      a \restrict command that prevents execution of further meta-commands,
      and teach pg_dump to issue that before any data coming from the source
      server.

      The PostgreSQL Project thanks Martin Rakhmanov, Matthieu Denais, and
      RyotaK for reporting this problem. (CVE-2025-8714)

    + Convert newlines to spaces in names included in comments in pg_dump
      output (Noah Misch)

      Object names containing newlines offered the ability to inject arbitrary
      SQL commands into the output script.  (Without the preceding fix,
      injection of psql meta-commands would also be possible this way.)
      CVE-2012-0868 fixed this class of problem at the time, but later work
      reintroduced several cases.

      The PostgreSQL Project thanks Noah Misch for reporting this problem.
      (CVE-2025-8715)

  * Drop obsolete patches:
    + hurd-iovec: implemented upstream
    + focal-arm64-outline-atomics: focal is EOL
    + jit-s390x, pgstat-report-conflicts-immediately.patch
      v8-0001-Fix-recovery-conflict-SIGUSR1-handling.patch: s390x workarounds

 -- Christoph Berg <myon@debian.org>  Tue, 08 Jul 2025 12:41:09 +0200

## postgresql-16 16.13

=== debian/changelog ===
postgresql-16 (16.13-0ubuntu0.24.04.1) noble-security; urgency=medium

  * New upstream version (LP: #2127668).

    + This release encompasses changes from upstream's 16.12 and 16.13
      releases. The former contains fixes for 4 CVEs (among other things), and
      the latter was a hotfix for regressions introcuced in 16.12.

    + A dump/restore is not required for those running 16.X.

    + However, if you are upgrading from a version earlier than 16.10, see
      those release notes as well please.

    + Guard against unexpected dimensions of oidvector/int2vector (Tom Lane)

      These data types are expected to be 1-dimensional arrays containing no
      nulls, but there are cast pathways that permit violating those
      expectations. Add checks to some functions that were depending on those
      expectations without verifying them, and could misbehave in consequence.
      (CVE-2026-2003)

    + Harden selectivity estimators against being attached to operators that
      accept unexpected data types (Tom Lane)

      contrib/intarray contained a selectivity estimation function that could
      be abused for arbitrary code execution, because it did not check that
      its input was of the expected data type. Third-party extensions should
      check for similar hazards and add defenses using the technique intarray
      now uses. Since such extension fixes will take time, we now require
      superuser privilege to attach a non-built-in selectivity estimator to an
      operator. (CVE-2026-2004)

    + Fix buffer overrun in contrib/pgcrypto's PGP decryption functions
      (Michael Paquier)

      Decrypting a crafted message with an overlength session key caused a
      buffer overrun, with consequences as bad as arbitrary code execution.
      (CVE-2026-2005)

    + Fix inadequate validation of multibyte character lengths (Thomas Munro,
      Noah Misch)

      Assorted bugs allowed an attacker able to issue crafted SQL to overrun
      string buffers, with consequences as bad as arbitrary code execution.
      After these fixes, applications may observe “invalid byte sequence for
      encoding” errors when string functions process invalid text that has
      been stored in the database. (CVE-2026-2006)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/16/release-16-12.html and
      https://www.postgresql.org/docs/16/release-16-13.html.

  * d/postgresql-16.NEWS: Update.

 -- Athos Ribeiro <athos@ubuntu.com>  Wed, 25 Feb 2026 11:12:24 -0300

postgresql-16 (16.11-0ubuntu0.24.04.1) noble-security; urgency=medium

  * New upstream version (LP: #2127667).

    + A dump/restore is not required for those running 16.X.

    + However, if you are upgrading from a version earlier than 16.10, see
      those release notes as well please.

    + Check for CREATE privileges on the schema in CREATE STATISTICS (Jelte
      Fennema-Nio)

      This omission allowed table owners to create statistics in any schema,
      potentially leading to unexpected naming conflicts. (CVE-2025-12817)

    + Avoid integer overflow in allocation-size calculations within libpq
      (Jacob Champion)

      Several places in libpq were not sufficiently careful about computing
      the required size of a memory allocation. Sufficiently large inputs
      could cause integer overflow, resulting in an undersized buffer, which
      would then lead to writing past the end of the buffer. (CVE-2025-12818)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/16/release-16-11.html.

  * d/postgresql-16.NEWS: Update NEWS file.

 -- Athos Ribeiro <athos@ubuntu.com>  Mon, 24 Nov 2025 09:58:56 -0300
